//CCJJ+DC-time dependence of charge, phase, voltage and CVC 16-07-2013
//CCJJ+DC-временной зависимость заряда, разности фаз и ВАХ 16-07-2013
#include<iostream>
#include<math.h>
#include<iomanip>
#include<stdio.h>
#include<stdlib.h>

int main()
	{
	using namespace std;
	const int N=9;	//Number of junctions
					//Количество контактов
	char c='p';		//for periodic BC put 'p' and for nonperiodic BC put 'n'
					//В случае периодических граничных условий вставте 'p' а не периодических 'n'
//####################################################################################
	int
		i,	//index of junctions
			//индекс по контактам
		g1,	//parameter for showing results on the screen
			//параметр для вывода результатов на экеран
		t,	//index of time
			//индекс по времени
		ti,	//number of time cycles from which of we begin integration
			//номер цикла по времени с которого начнается интегрирование
		a=1,//parameter for direction of current
			//параметр для определения направлении тока
		tN,	//total number of time cycles
			//количество точек (циклов) по времени
		ICounter,//счетчик для тока что бы учытывать рост времени
		M=N,	//M используется как номер ДП(JJ) при учете граничных условий
		Itime1finish=0,	//if you want to finish program after time dependencies put here 1 instead of 0
						//если вы хотите приостановить программу после временной зависимости вствте '1' в место '0'
		pt=0,	//parameter to check recording of time dependence
				//параметр для проверки записи временной зависимости
		at=1;	//in up or down for time dependence put 1 or -1
				//в случае возростания или убываения тока для временной зависимости соответсвенно вставте 1 или -1
//######################################################################################
	double
		Ti=50,	//Initial value of time averaging
				//Начальная значения времени усреднения
		Tf0=500,//Time domain for one step of current
				//Временной домен для одного шага тока
		Tf1=500,//Time domain for one step of current in time dependence procedure 
				//Временной домен для одного шага тока при вычислении временной зависимости
		TP=0.05,//Step of time
				//Шаг по времени
		JP0=0.005,	//Step of current outside current interval [Imore1,Imore2]
					//Шаг по току вне интервала [Imore1,Imore2]
		JP1=0.0001,	//Step of current inside current interval [Imore1,Imore2]
					//Шаг по току в интервале [Imore1,Imore2]
		Imore1=0.5,
		Imore2=0.6,
		I0=0.1,	//Initial value of bias current
				//Начальное значения тока 
		Imax=1.2,	//Maximal value of bias current
				//Максимальное значения тока
		noismax=1e-8,//Noise amplitude of bias current
					//Амплитуда шума тока
		Omega=0,//Частота внешнего излучения
		Amp=0,//Амплитуда внешнего излучения
		alpha =1,	//Coupling parameter
					//Параметр связи
		beta=0.2,	//Dissipation parameter
					//Параметр диссипации
		gamma =0,	//Parameter for boundary condition
					//Параметр для граничных услвий
		Itime1=0.5,//Minimal current value for time dependence recording
					//Минамальное значения тока для записи временной зависимости
		Itime2=0.5,//Maximal current value for time dependence recording
					//Максимальное значения тока для записи временной зависимости
		v,	//Total voltage
			//Суммарное напряжение
		Irand[N+2],	//Current noise
					//Шум тока
		intV[N+2],	//Variable for voltage integration
					//Переменный для интегрирования напряжении
		Vav[N+2],	//Variable for voltage averaging
					//Переменный для усреднения напряжении
		Vav0[N+2],//Значение средней напряжении в предыдущем шаге по току
		dVdI[N+2],//Производная напряжении по току в каждом ДП
		dVdItotal,//Суммарна производная напряжении по току
		//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		//Runge-Kutta coefficients
		//Коэффициенты Рунге-Кутта
		P1[N+2],V1[N+2],
		P2[N+2],V2[N+2],
		P3[N+2],V3[N+2],
		P4[N+2],V4[N+2],
		//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		V[N+2],	//Variable for Voltage in each junction at fixed time
				//Переменный для напряжение в каждом контакте в фиксированном времени
		dph[N+2],
		ph[N+2],//Variable for phase differences in each junction at fixed time
				//Переменный для разности фаз в каждом контакте в фиксированном времени
		Ch[N+2],//Variable for charge in each layer at fixed time
				//Переменный для заряда в каждом контакте в фиксированном времени
		time=0,	//Time for recording
				//Время для записи
		I,	//Bias current
			//Входной ток
		Tf=Tf0,JP=JP0,Jc=1;
//#######################################################################################
	//Creation result's files
	//Создания файлов для результатов
	FILE *f,*f1,*f11,*f5,*f6,*dvdi;
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	//file for total CVC
	//файл для полного ВАХ
	f=fopen("Voltage.dat","w");	
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	//file for CVC in each junction
	//файл для ВАХ в каждом контакте
	f1=fopen("Voltage_j.dat","w");	
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	//file for charge-time dependence in each layer
	//файл для временной зависимости заряда в каждом слое
	f11=fopen("Ch(time).dat","w");	
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	//file for Voltage-time dependence in each junction
	//файл для временной зависимости напряжении в каждом контакте
	f5=fopen("V_j(time).dat","w");	
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	//file for phase difference-time dependence in each junction
	//файл для временной зависимости разность фаз в каждом контакте
	f6=fopen("ph(time).dat","w");
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	//file for current derivative of voltage
	//файл для производной напряжении по току
	dvdi=fopen("dvdi.dat","w");
	//*****************************************************************
	tN=(Tf/TP);
	ti=tN*Ti/Tf;
	//***************************************	
	//Cycle for calculation of initial condition
	//Цикл для вычисления начальных условий
	i=0;
	do{	ph[i]=0;
		dph[i]=0;
		intV[i]=0;
		Vav[i]=0;
		V[i]=0;
		Ch[i]=0;
	}while(++i<=N);
	//*****************************************
	ICounter=0;
	v=0;
	I=I0;
	g1=0;
//#######################################################################
	//Generation of noise for Windows 
	//Генерация шума для Windows
	long int ranmax=0,ran=0;
	long long x1;
	i=1;
	do{	asm("rdtsc" : "=A"(x1));
		srand(x1);
		ran=rand();
		if(ranmax<ran)ranmax=ran;
	}while(++i<=100);
	cout<<"random max is :"<<ranmax<<endl;
	float irand;
	int randa[2000];
	i=1;
	do{	irand=rand();
		irand=2*(irand/ranmax-0.5);
		ran=100*irand;
		randa[ran+100]=randa[ran+100]+1;
	}while(++i<=1000000);

/*	//Generation of noise for Linux
	//Генерация шума для Linux	
	char *a12;
	unsigned  i1,i2=1;
	long int ranmax=0,ran=0;
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	i=1;
	do{	initstate(i1,a12,i2);
		ran=random();
		if(ranmax<ran)ranmax=ran;
	}while(++i<=100000);
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	cout<<"random max is :"<<ranmax<<endl;
	float rand;
	int randa[2000];
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	i=1;
	do{	initstate(i1,a12,i2);
		rand=random();
		rand=2*(rand/ranmax-0.5);
		ran=100*rand;
		randa[ran+100]=randa[ran+100]+1;
	}while(++i<=1000000);
*/
//####################################################################################
	do{	// Here the cycle of current begins
		//Здесь начинается цикл по току
		i=1;
		do{Vav0[i]=Vav[i];}while(++i<=N);
		
		t=0;
		do{	//Here the cycle of time begins
			//Здесь начинается цикл по времени
			//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
			//Noise calculation for Linux
			//вычисления шума для Linux
		/*	i=1;
			do{	initstate(i1,a12,i2);
				rand=random();
				rand=2*(rand/ranmax-0.5);
				Irand[i]=noismax*rand*Jc;
			}while(++i<=N);
		*/	//Noise calculation for each JJ (for Windows)
			//Вычисления шума для каждого ДП (для Windows)
			i=1;
			do{	irand=rand();
				irand=2*(irand/ranmax-0.5);
				Irand[i]=noismax*irand*Jc;
			}while(++i<=N);
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	//Starting of Runge-Kutta method
	//Начало метода Рунге-Кутта
			//$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
			//The first coefficients of Runge-Kutta method
			//Первые коэффициенты метода Рунге-Кутта
			if(c=='n'){	i=1;
			dph[i]=(V[i])-alpha*(V[i+1]-(1+gamma)*V[i]);
			V1[i]=TP*(I+Irand[i]+Amp*sin(Omega*(t*TP+ICounter*tN*TP))
				-Jc*sin(ph[i])-beta*dph[i]);
			P1[i]=TP*dph[i];
			i=N;
			dph[i]=(V[i])-alpha*(V[i-1]-(1+gamma)*V[i]);
			V1[i]=TP*(I+Irand[i]+Amp*sin(Omega*(t*TP+ICounter*tN*TP))
				-Jc*sin(ph[i])-beta*dph[i]);
			P1[i]=TP*dph[i];i=2;}
			if(c=='p'){i=1;M=N+1;V[0]=V[N];V[N+1]=V[1];}
			do{	dph[i]=(V[i])-alpha*(V[i-1]+V[i+1]-2*V[i]);
				V1[i]=TP*(I+Irand[i]+Amp*sin(Omega*(t*TP+ICounter*tN*TP))
					-Jc*sin(ph[i])-beta*dph[i]);
				P1[i]=TP*dph[i];
			}while(++i<M);
			//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
			//The second coefficients of Runge-Kutta method
			//Вторые коэффициенты метода Рунге-Кутта
			if(c=='n'){	i=1;	
			dph[i]=(V[i]+V1[i]/2)-alpha*((V[i+1]+V1[i+1]/2)-(1+gamma)*(V[i]+V1[i]/2));
			V2[i]=TP*(I+Irand[i]+Amp*sin(Omega*(TP*t+TP/2+ICounter*tN*TP))
					-Jc*sin(ph[i]+P1[i]/2)-beta*dph[i]);
			P2[i]=TP*dph[i];
			i=N;
			dph[i]=(V[i]+V1[i]/2)-alpha*((V[i-1]+V1[i-1]/2)-(1+gamma)*(V[i]+V1[i]/2));
			V2[i]=TP*(I+Irand[i]+Amp*sin(Omega*(TP*t+TP/2+ICounter*tN*TP))
				-Jc*sin(ph[i]+P1[i]/2)-beta*dph[i]);
			P2[i]=TP*dph[i];i=2;}
			if(c=='p'){i=1;M=N+1;V[0]=V[N];V[N+1]=V[1];V1[0]=V1[N];V1[N+1]=V1[1];}
			do{	dph[i]=(V[i]+V1[i]/2)-alpha*((V[i-1]+V1[i-1]/2)+(V[i+1]+V1[i+1]/2)-2*(V[i]+V1[i]/2));
			V2[i]=TP*(I+Irand[i]+Amp*sin(Omega*(TP*t+TP/2+ICounter*tN*TP))
				-Jc*sin(ph[i]+P1[i]/2)-beta*dph[i]);
			P2[i]=TP*dph[i];
			}while(++i<M);
			//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
			//The third coefficients of Runge-Kutta method
			//Третые коэффициенты метода Рунге-Кутта
			if(c=='n'){	i=1;
			dph[i]=(V[i]+V2[i]/2)-alpha*((V[i+1]+V2[i+1]/2)-(1+gamma)*(V[i]+V2[i]/2));
				V3[i]=TP*(I+Irand[i]+Amp*sin(Omega*(TP*t+TP/2+ICounter*tN*TP))
					-Jc*sin(ph[i]+P2[i]/2)-beta*dph[i]);
			P3[i]=TP*dph[i];
			i=N;
			dph[i]=(V[i]+V2[i]/2)-alpha*((V[i-1]+V2[i-1]/2)-(1+gamma)*(V[i]+V2[i]/2));
			V3[i]=TP*(I+Irand[i]+Amp*sin(Omega*(TP*t+TP/2+ICounter*tN*TP))
					-Jc*sin(ph[i]+P2[i]/2)-beta*dph[i]);
			P3[i]=TP*dph[i];i=2;}
			if(c=='p'){i=1;M=N+1;V[0]=V[N];V[N+1]=V[1];V2[0]=V2[N];V2[N+1]=V2[1];}
			do{	dph[i]=(V[i]+V2[i]/2)-alpha*((V[i-1]+V2[i-1]/2)+(V[i+1]+V2[i+1]/2)-2*(V[i]+V2[i]/2));
				V3[i]=TP*(I+Irand[i]+Amp*sin(Omega*(TP*t+TP/2+ICounter*tN*TP))
					-Jc*sin(ph[i]+P2[i]/2)-beta*dph[i]);
				P3[i]=TP*dph[i];
			}while(++i<M);
			//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
			//The fourth coefficients of Runge-Kutta method
			//Четвертые коэффициенты метода Рунге-Кутта
			if(c=='n'){	i=1;
			dph[i]=(V[i]+V3[i])-alpha*((V[i+1]+V3[i+1])-(1+gamma)*(V[i]+V3[i]));
			V4[i]=TP*(I+Irand[i]+Amp*sin(Omega*(TP*t+TP+ICounter*tN*TP))
				-Jc*sin(ph[i]+P3[i])-beta*dph[i]);
			P4[i]=TP*dph[i];
			i=N;
			dph[i]=(V[i]+V3[i])-alpha*((V[i-1]+V3[i-1])-(1+gamma)*(V[i]+V3[i]));
			V4[i]=TP*(I+Irand[i]+Amp*sin(Omega*(TP*t+TP+ICounter*tN*TP))
				-Jc*sin(ph[i]+P3[i])-beta*dph[i]);
			P4[i]=TP*dph[i];i=2;}
			if(c=='p'){i=1;M=N+1;V[0]=V[N];V[N+1]=V[1];V3[0]=V3[N];V3[N+1]=V3[1];}
			do{	dph[i]=(V[i]+V3[i])-alpha*((V[i-1]+V3[i-1])+(V[i+1]+V3[i+1])-2*(V[i]+V3[i]));
				V4[i]=TP*(I+Irand[i]+Amp*sin(Omega*(TP*t+TP+ICounter*tN*TP))
					-Jc*sin(ph[i]+P3[i])-beta*dph[i]);
				P4[i]=TP*dph[i];
			}while(++i<M);
			//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
			i=1;
			do{ ph[i]=ph[i]+(P1[i]+2*P2[i]+2*P3[i]+P4[i])/6;
		 	    V[i]=V[i]+(V1[i]+2*V2[i]+2*V3[i]+V4[i])/6;
				if (t>ti)intV[i]=V[i]*TP+intV[i];
			}while(++i<=N);
	//Ending of Runge-Kutta method
	//Конец метода Рунге-Кутта
	//$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
		// Starting of time dependence calculation
		// Начало вычисления временных зависимостей
			if((I<(Itime2+JP1/2))&&(I>(Itime1-JP1/2))&&(a==at))
				{pt=1;tN=Tf1/TP;Tf=Tf1;
				//Recording time Formula
				//Формула записываемого времени
				if(at==-1){time=t*TP-(TP*tN*(Itime2-I)*at)/JP;}
				if(at==1){time=t*TP+(TP*tN*(I-Itime1)*at)/JP;}
				//**************************************
				//Time recording
				//Запись времени		
				fprintf(f11,"%f\t",time);	
				fprintf(f5,"%f\t",time);
				fprintf(f6,"%f\t",time);
				//**************************************
				//Here phase difference will be recorded
				//Здесь записывается разность фаз
				i=1;
				do{	fprintf(f6,"%e\t",ph[i]);
				}while(++i<=N);
				//*************************************************
				//Calculation of charge value for middle layers
				//Вычисление значения заряда в промежуточных слоях	
				i=1;
				do{	Ch[i]=alpha*(V[i+1]-V[i]);	 
				}while(++i<=N-1);
				//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
				//Calculation of charge value for last layer at periodic boundary condition (BC)
				//at periodic BC, charge value for first and last layers are identical
				//Вычисление значения заряда на последном слое при периодических граничных условий (ГУ)
				//при периодическом ГУ значения заряда на первом и последном слоях идентичны
				if(c=='p'){Ch[N]=alpha*(V[1]-V[N]);}
				//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
				if(c=='n'){
					//Calculation of charge value for first layer at nonperiodic BC
					//вычисления значения заряда на первом слое при не периодических ГУ
					Ch[0]=alpha*(V[1]);
					//Calculation of charge value for last layer at nonperiodic BC
					//вычисления значения заряда на последном слое при не периодических ГУ
					Ch[N]=-alpha*(V[N]);
					//Here will be recorded charge in first layer at nonperiodic BC
					//Здесь записывается заряд на первом слое при не периодических ГУ
					fprintf(f11,"%e\t",Ch[0]);}
				//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
				i=1;
				do{	//Here will be recorded charge in all layers
					//Здесь записывается заряд на всех слоях
					fprintf(f11,"%e\t",Ch[i]);
					//Here will be recorded voltage in all junctions
					//Здесь записывается напряжение на всех контактах 
					fprintf(f5,"%e\t",V[i]);
				}while(++i<=N);
				//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
				//Here will be recorded bias current
				//Здесь записывается входной ток
				fprintf(f11,"%f\t",I);
				fprintf(f5,"%f\t",I);
				fprintf(f6,"%f\t",I);
				//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
				//Going to new line
				//Переход на новую строку
				fprintf(f11,"\n");
				fprintf(f5,"\n");
				fprintf(f6,"\n");
			}else{tN=Tf0/TP;Tf=Tf0;};
	// Ending of time dependence calculation
	//Конец вычисления временных зависимостей
	//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
		//Here the cycle of time finishs
		//Здесь цикл по времени закончивается
		}while(++t<tN+1);
		//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		//Voltage averaging
		//Усреднение напряжения
		i=1;
		do{	Vav[i]=intV[i]/(Tf-Ti);
			intV[i]=0;
		}while(++i<=N);
		//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		// total voltage calculation
		//Вычисление суммарного напряжения
		v=0;
		dVdItotal=0;
		i=1;
		do{	v=Vav[i]+v;
			dVdI[i]=(Vav[i]-Vav0[i])/JP;
			dVdItotal=dVdItotal+dVdI[i];
		}while(++i<=N);
		//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		//showing results on the screen
		//вывод результатов на экран
		if ((g1==0))
			{cout<<"\n\nI:"<<I<<"\tV:"<<v;}
		//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		//Here will be recorded bias Current and total voltage
		//Здесь записывается входной ток и суммарное напряжение
		fprintf(f,"%f\t%e\n",I,v);
		fprintf(f1,"%f\t%e\t",I,v);
		fprintf(dvdi,"%f\t%e\t",I,dVdItotal);
		//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		//Here will be recorded voltage in each junction
		//Здесь записывается напряжение на каждом контакте
		i=1;
		do{	fprintf(f1,"%e\t",Vav[i]);
			fprintf(dvdi,"%e\t",dVdI[i]);
		}while(++i<=N);
		//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		//Going to new line
		//Переход на новую строку
		fprintf(f1,"\n");
		fprintf(dvdi,"\n");
		//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		//Condition for breaking
		//Условие для приостановления
		if ((I<=0)&&(a==-1))break;
		//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		//Condition for changing current dirrection
		//Условие для изменения направлении тока
		if (I>Imax){	
			cout<<"here is max of current so we  go back"<<endl;
			a=-1;};
		//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		ICounter=ICounter+1;
		//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		//Here bias current will be changed
		//Здесь изменяется направление тока
		I=I+a*JP;
		//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		//Condition for breaking after recoding time dependence
		//Условие для приостановления после записи временных зависимостей
		if((pt==1)&&(Itime1finish==1)&&(a==at)&&(v>0.1))
		if((I>Itime2+JP1/2)||(I<Itime1-JP1/2))
			{	
				cout<<"\n"<<"the program is written to "
				<<"finish here, if you don't like so change Itime1finish to 0"<<"\n";
				break;
			};
		//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		//Condition for chenging step of current
		//Условие для изменения шага по току
		if ((I<=Imore2+JP1/2)&&(I>=Imore1-JP1/2)&&(a==-1)){JP=JP1;tN=Tf1/TP;Tf=Tf1;}else{JP=JP0;tN=Tf0/TP;Tf=Tf0;};
		//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	//Here cycle of current finishs
	//Здесь закончивается цикл по току
	}while(I<=100);
	//**********************
	// Here all files will be closed
	//Здесь все файлы закрываются
	fclose(f);
	fclose(f1);
	fclose(f11);
	fclose(f5);
	fclose(f6);
	fclose(dvdi);
return(0);
}
